#ifndef __UTILITIES__H
#define __UTILITIES__H
#include "global_vars.h"
using namespace std;

//******************************************************//
//********QuickSort for ordering Low to High************//
//******************************************************//
// Used to distiguish patterns as they are sorted by
// The unique spacings between all the dots in each pattern
void q_sort(double numbers[], int left, int right)
{
   double pivot, l_hold, r_hold;
   l_hold = left;
   r_hold = right;
   pivot = numbers[left];
   while (left < right)
   {
      while ((numbers[right] >= pivot) && (left < right))
      right--;
      if (left != right)
      {
	 numbers[left] = numbers[right];
	 left++;
      }
      while ((numbers[left] <= pivot) && (left < right))
	 left++;
      if (left != right)
      {
	  numbers[right] = numbers[left];
	  right--;
      }
   }
   numbers[left] = pivot;
   pivot = left;
   left = l_hold;
   right = r_hold;
   if (left < pivot)
      q_sort(numbers, left, pivot-1);
   if (right > pivot)
      q_sort(numbers, pivot+1, right);
}

//signum function
double sign(double x){
	if (x >= 0){
		return 1;
	}
	else{
		return -1;
	}
}

//normalize angle to -pi -> pi
double normalize_angle(double theta){
	while( theta > PI ){
		theta -= 2*PI;
	}
	while(theta < -PI){
		theta += 2*PI;
	}
	return theta;
}

#endif